--- traceevent/event-parse.c.orig
+++ ./traceevent/event-parse.c
@@ -5121,12 +5121,17 @@
 	const char *msg;
 
 	if (errnum >= 0) {
+#if defined(__GLIBC__)
 		msg = strerror_r(errnum, buf, buflen);
 		if (msg != buf) {
 			size_t len = strlen(msg);
 			memcpy(buf, msg, min(buflen - 1, len));
 			*(buf + min(buflen - 1, len)) = '\0';
 		}
+#else
+		if (strerror_r(errnum, buf, buflen))
+			snprintf(buf, buflen, "errnum %i", errnum);
+#endif
 		return 0;
 	}
 
